blob: ec71d3bcb0f6a94be12391c34d49f4232bf8aaae [file] [log] [blame]
Sean Condonf6af2a52018-08-19 10:43:24 +01001"""
2 Copyright 2018-present Open Networking Foundation
3
4 Licensed under the Apache License, Version 2.0 (the "License");
5 you may not use this file except in compliance with the License.
6 You may obtain a copy of the License at
7
8 http://www.apache.org/licenses/LICENSE-2.0
9
10 Unless required by applicable law or agreed to in writing, software
11 distributed under the License is distributed on an "AS IS" BASIS,
12 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 See the License for the specific language governing permissions and
14 limitations under the License.
15"""
16
17"""
18 Rules to build the ONOS GUI 2
19
Sean Condon0c577f62018-11-18 22:40:05 +000020 The GUI2 Angular 7 elements are built here with Angular CLI 'ng'
Sean Condonf6af2a52018-08-19 10:43:24 +010021 Some work is being done in the Bazel community to integrate Bazel and
Sean Condon0c577f62018-11-18 22:40:05 +000022 Angular 7, (Angular Buildtools Convergence -
Sean Condonf6af2a52018-08-19 10:43:24 +010023 https://docs.google.com/document/d/1OlyiUnoTirUj4gecGxJeZBcjHcFr36RvLsvpBl2mxA8/preview)
24 but it is in the very early stages (Aug'18) and not yet fit
25 for production and at present it works as a replacement for Angular CLI
26 (which is not desirable).
27
28 There are plans to extend Bazel it to work with Angular CLI, and if works
29 well this Bazel file may be rearchiteced in future.
30
31 Bazel and npm are incompatibe in how they deal with files. npm likes to
32 follow links to get back to the original canonical path names, and bazel
33 uses links extensively when populating the sandbox. To get around these
34 problems, the rules that follow use filegroups to specify the files as
35 dependencies and then use a genrule to convert the files into a tar ball.
36 Once the tar ball is unrolled into the sandbox, the links are broken, but
37 the build is still hermetic since those files are referred to as dependencies in the genrule.
38"""
39
Sean Condonb2c483c2019-01-16 20:28:55 +000040COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + CLI + [
Sean Condonf6af2a52018-08-19 10:43:24 +010041 "@javax_ws_rs_api//jar",
42 "@servlet_api//jar",
43 "@jetty_websocket//jar",
Sean Condonb2c483c2019-01-16 20:28:55 +000044 "@jetty_websocket_api//jar",
Sean Condonf6af2a52018-08-19 10:43:24 +010045 "@jetty_util//jar",
46 "@jersey_media_multipart//jar",
47 "@jersey_server//jar",
Ray Milkey427e9752018-11-15 16:34:48 -080048 "@jersey_hk2//jar",
Sean Condonf6af2a52018-08-19 10:43:24 +010049 "//utils/rest:onlab-rest",
50 "//core/store/serializers:onos-core-serializers",
51]
52
53TEST_DEPS = TEST + [
54 "//core/api:onos-api-tests",
55 "//drivers/default:onos-drivers-default",
56]
57
58"""
59 Files that get put at the top level of the tar ball
60"""
61
62filegroup(
63 name = "_root_level_files",
64 srcs =
65 [
66 ":angular.json",
67 ":karma.conf.js",
68 ":package.json",
69 ":package-lock.json",
70 ":protractor.conf.js",
71 ":src/main/tsconfig.json",
72 ":src/main/tslint.json",
73 ":tsconfig.json",
74 ],
75)
76
77filegroup(
78 name = "_e2e_test_files",
79 srcs = [
80 ":e2e/app.e2e-spec.ts",
81 ":e2e/app.po.ts",
82 ":e2e/tsconfig.e2e.json",
83 ],
84)
85
86"""
87 Files that get put into the WEB-INF directory of the tar ball
88"""
89
90filegroup(
91 name = "_web_inf_classes_files",
92 srcs =
93 [
94 ":src/main/webapp/error.html",
95 ":src/main/webapp/login.html",
96 ":src/main/webapp/nav.html",
97 ":src/main/webapp/not-ready.html",
Sean Condon55c30532018-10-29 12:26:57 +000098 ":src/main/webapp/onos.global.css",
Sean Condonf6af2a52018-08-19 10:43:24 +010099 ],
100)
101
102"""
Sean Condonf6af2a52018-08-19 10:43:24 +0100103 Run ng build to create outputs in production mode
104 See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for details of the Angular CLI output
Sean Condon5ca00262018-09-06 17:55:25 +0100105
106 To avoid the overhead of having several "npm install" invocations, we just do
Sean Condon0c577f62018-11-18 22:40:05 +0000107 it once in the //web/gui2-fw-lib which is really the core for the whole Angular 7
Sean Condon5ca00262018-09-06 17:55:25 +0100108 structure in ONOS. This copies files in to node_modules, but because the gui2-fw-lib
109 has not been generated at that time we copy it in separately below with the 'tar' cmd
110 and then 'mv'
Sean Condonf6af2a52018-08-19 10:43:24 +0100111"""
112
113genrule(
114 name = "_onos-gui2-ng-build",
115 srcs = [
116 "@nodejs//:bin/npm",
117 "@nodejs//:bin/node",
Sean Condonf6af2a52018-08-19 10:43:24 +0100118 "@nodejs//:bin/nodejs/bin/node",
119 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100120 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
121 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
122 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condonff85fbe2019-03-16 14:28:46 +0000123 "//web/gui2-topo-lib:gui2-topo-lib-build",
Sean Condon87b78502018-09-17 20:53:24 +0100124 "//apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build",
Sean Condon5ca00262018-09-06 17:55:25 +0100125 ":_root_level_files",
Sean Condonf6af2a52018-08-19 10:43:24 +0100126 ":_web_app_all",
Boyuan Yan6b23b382019-06-04 11:59:35 -0700127 "//apps/roadm/web/roadm-gui:roadm-gui-lib-build",
Sean Condonf6af2a52018-08-19 10:43:24 +0100128 ],
129 outs = [
130 "onos-gui2-ng-build-prod.log",
131 "onos-gui2-ng-build.jar",
132 ],
133 cmd = "ROOT=`pwd` &&" +
134 " export HOME=. &&" +
135 " export XDG_CONFIG_HOME=$(@D)/config &&" +
136 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100137 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
138 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100139 " mkdir -p web/gui2 && cd web/gui2 &&" +
140 " jar xf ../../$(location :_web_app_all) &&" +
141 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100142 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
143 " mv package/ node_modules/gui2-fw-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100144 # Add in modules from external packages
Sean Condonff85fbe2019-03-16 14:28:46 +0000145 " GUI2_TOPO_LIB_FILES=($(locations //web/gui2-topo-lib:gui2-topo-lib-build)) &&" + # An array of filenames - sorted by time created
146 " tar xf $$ROOT/$${GUI2_TOPO_LIB_FILES[0]} &&" +
147 " mv package/ node_modules/gui2-topo-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100148 " FM_GUI2_LIB_FILES=($(locations //apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build)) &&" + # An array of filenames - sorted by time created
149 " tar xf $$ROOT/$${FM_GUI2_LIB_FILES[0]} &&" +
150 " mv package/ node_modules/fm-gui2-lib/ &&" +
Boyuan Yan6b23b382019-06-04 11:59:35 -0700151 " ROADM_GUI_LIB_FILES=($(locations //apps/roadm/web/roadm-gui:roadm-gui-lib-build)) &&" + # An array of filenames - sorted by time created
152 " tar xf $$ROOT/$${ROADM_GUI_LIB_FILES[0]} &&" +
153 " mv package/ node_modules/roadm-gui-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100154 # End of add in modules from external packages
Sean Condon5ca00262018-09-06 17:55:25 +0100155 " mkdir -p src/main/webapp/app/fw &&" +
156 " (cd src/main/webapp/app/fw &&" +
157 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100158 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700159 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100160 " node -v > ../../$(location onos-gui2-ng-build-prod.log) &&" +
161 " npm -v >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
Sean Condon0c577f62018-11-18 22:40:05 +0000162 " ng version >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
163 " ng build --extract-css --prod --preserve-symlinks" +
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000164 " --base-href /onos/ui/ --deploy-url /onos/ui/ >> $$ROOT/$(location onos-gui2-ng-build-prod.log) 2>&1 ||" +
Sean Condon87b78502018-09-17 20:53:24 +0100165 " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" +
166 " else " +
167 " echo 'Error running \'ng build\' on \'//web/gui2:_onos-gui2-ng-build\'. \\\n" +
168 " See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for more details' >&2;" +
169 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
170 " exit 1;" +
171 " fi;" +
Sean Condon95fb5742019-04-02 12:16:55 +0100172 " cp -r node_modules/gui2-fw-lib/assets src/main/webapp/dist &&" +
173 " cd src/main/webapp/dist &&" +
174 " jar Mcf $$ROOT/$(location onos-gui2-ng-build.jar) .",
Sean Condon0c577f62018-11-18 22:40:05 +0000175 message = "Angular CLI 7 build",
Sean Condonf6af2a52018-08-19 10:43:24 +0100176)
177
178"""
179 Run 'ng test' to run Angular test and 'ng lint' for checkstyle
180 See bazel-genfiles/web/gui2/onos-gui2-ng-lint.log or
181 bazel-genfiles/web/gui2/onos-gui2-ng-test.log for details of the Angular CLI output
182"""
183
184genrule(
185 name = "_onos-gui2-ng-test-genrule",
186 srcs = [
187 "@nodejs//:bin/npm",
188 "@nodejs//:bin/node",
Sean Condonf6af2a52018-08-19 10:43:24 +0100189 "@nodejs//:bin/nodejs/bin/node",
190 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100191 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
192 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
193 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condonf6af2a52018-08-19 10:43:24 +0100194 ":_web_app_all",
195 ":_web_app_tests",
196 ":_angular_all",
197 ],
198 outs = [
199 "onos-gui2-ng-ver.log",
200 "onos-gui2-ng-lint.log",
201 "onos-gui2-ng-test.log",
202 ],
203 cmd = " ROOT=`pwd` &&" +
204 " export HOME=. &&" +
205 " export XDG_CONFIG_HOME=$(@D)/config &&" +
206 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100207 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
208 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100209 " mkdir -p web/gui2 &&" +
210 " cd web/gui2 &&" +
211 " jar xf ../../$(location :_angular_all) &&" +
212 " jar xf ../../$(location :_web_app_all) &&" +
213 " jar xf ../../$(location :_web_app_tests) &&" +
214 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100215 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
216 " mv package/ node_modules/gui2-fw-lib/ &&" +
217 " mkdir -p src/main/webapp/app/fw &&" +
218 " (cd src/main/webapp/app/fw &&" +
219 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100220 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700221 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100222 " node -v > ../../$(location onos-gui2-ng-ver.log) &&" +
223 " npm -v >> ../../$(location onos-gui2-ng-ver.log) &&" +
Sean Condon50855cf2018-12-23 15:37:42 +0000224 " ng version >> ../../$(location onos-gui2-ng-ver.log);" +
225 " ng lint > ../../$(location onos-gui2-ng-lint.log) 2>&1 ||" +
226 " if [ $$? -eq 0 ]; then echo 'Successfully ran lint';" +
227 " else " +
228 " echo 'Error running \'ng lint\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" +
229 " See bazel-genfiles/web/gui2/onos-gui2-ng-lint.log for more details' >&2;" +
230 " exit 1;" +
231 " fi;" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100232 " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome
233 " export CHROME_BIN=/usr/bin/chromium-browser; " +
234 " elif [ -f /opt/google/chrome/chrome ]; then " +
235 " export CHROME_BIN=/opt/google/chrome/chrome; " +
236 " else " +
237 " MSG='Warning: Step onos-gui2-ng-test skipped because \\n" +
238 " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" +
239 " Install Google Chrome or Chromium Browser to allow this step to run.';" +
240 " echo -e $$MSG >&2;" +
241 " echo -e $$MSG > ../../$(location onos-gui2-ng-test.log);" +
242 " exit 0;" +
243 " fi;" +
244 " ng test --preserve-symlinks --code-coverage --browsers=ChromeHeadless" +
245 " --watch=false > ../../$(location onos-gui2-ng-test.log) 2>&1 ||" +
246 " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" +
247 " else " +
248 " echo 'Error running \'ng test\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" +
249 " See bazel-genfiles/web/gui2/onos-gui2-ng-test.log for more details' >&2;" +
250 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
251 " exit 1;" +
252 " fi;",
Sean Condon0c577f62018-11-18 22:40:05 +0000253 message = "Angular CLI 7 lint and test",
Sean Condonf6af2a52018-08-19 10:43:24 +0100254)
255
256"""
257 Make a jar file of all the webapp files. Useful for breaking symblic links in the sandbox
258"""
259
260genrule(
261 name = "_web_app_all",
262 srcs = glob(
263 [
264 "src/main/webapp/**",
265 ],
266 exclude = [
267 "src/main/webapp/**/*.spec.ts", # Don't track tests here
268 "src/main/webapp/tests/**",
269 "src/main/webapp/node_modules/**",
270 "src/main/webapp/dist/**",
271 "src/main/webapp/doc/**",
Sean Condon87b78502018-09-17 20:53:24 +0100272 "src/main/webapp/app/fw/**",
Sean Condonf6af2a52018-08-19 10:43:24 +0100273 ],
274 ),
275 outs = ["web_app_all.jar"],
276 cmd = "cd web/gui2 &&" +
277 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
278 " jar Mcf ../../$@ src/main/webapp",
279)
280
281"""
282 Make a jar file of all the webapp test (*.spec.ts) files.
283"""
284
285genrule(
286 name = "_web_app_tests",
287 srcs = glob(
288 [
289 "src/main/webapp/**/*.spec.ts",
290 ],
291 exclude = [
292 "src/main/webapp/tests/**",
293 "src/main/webapp/node_modules/**",
294 "src/main/webapp/dist/**",
295 "src/main/webapp/doc/**",
296 ],
297 ),
298 outs = ["web_app_tests.jar"],
299 cmd = "cd web/gui2 &&" +
300 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
301 " jar Mcf ../../$@ src/main/webapp",
302)
303
304"""
305 Make a jar file of all the supporting files. Useful for breaking symblic links in the sandbox
306"""
307
308genrule(
309 name = "_angular_all",
310 srcs = [
311 ":_e2e_test_files",
312 ":_root_level_files",
313 ],
314 outs = ["angular_all.jar"],
315 cmd = " cd web/gui2 && jar Mcf ../../$@ .",
316)
317
318"""
319 Builds the java jar for the java code provided by the GUI2
320"""
321
322osgi_jar_with_tests(
323 name = "_onos-gui2-base-jar",
Sean Condon87b78502018-09-17 20:53:24 +0100324 srcs =
325 glob([
326 "src/main/java/**",
327 ]) + [
328 "//web/gui:onos-gui-java-for-gui2",
329 ],
Sean Condonb2c483c2019-01-16 20:28:55 +0000330 exclude_tests = [
331 "org.onosproject.ui.impl.AbstractUiImplTest",
332 "org.onosproject.ui.impl.topo.model.AbstractTopoModelTest",
333 ],
334 karaf_command_packages = [
335 "org.onosproject.ui.impl.cli",
336 "org.onosproject.ui.impl.topo",
337 ],
Sean Condon3c8e5582018-08-28 23:22:43 +0100338 suppress_checkstyle = True,
Sean Condonf6af2a52018-08-19 10:43:24 +0100339 test_deps = TEST_DEPS,
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000340 web_context = "/onos/ui",
Sean Condonf6af2a52018-08-19 10:43:24 +0100341 deps = COMPILE_DEPS,
342)
343
344"""
345 Builds the tar ball for the ONOS GUI2
346"""
347
348genrule(
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000349 name = "onos-web-gui2",
Sean Condonf6af2a52018-08-19 10:43:24 +0100350 srcs = [
351 ":_onos-gui2-ng-build",
352 ":_onos-gui2-base-jar",
353 ":_web_inf_classes_files",
Sean Condonb2c483c2019-01-16 20:28:55 +0000354 "//web/gui:onos-gui-lion-for-gui2",
Sean Condon0d064ec2019-02-04 21:53:53 +0000355 "//web/gui:onos-gui-data-for-gui2",
Sean Condon3c8e5582018-08-28 23:22:43 +0100356 "src/main/webapp/WEB-INF/web.xml",
Sean Condonf6af2a52018-08-19 10:43:24 +0100357 ],
358 outs = ["onos-gui2.jar"],
359 cmd = " ROOT=`pwd` &&" +
360 " mkdir -p web/gui2/WEB-INF/classes &&" +
361 " cd web/gui2 &&" +
362 " BUILD_FILES=($(locations :_onos-gui2-ng-build)) &&" + # An array of filenames - sorted by time created
363 " for i in $(locations :_web_inf_classes_files); do cp $$ROOT/$$i ./WEB-INF/classes/; done &&" +
364 " (cd WEB-INF/classes && jar xf $$ROOT/$${BUILD_FILES[1]}) &&" +
365 " jar xf $$ROOT/$(location :_onos-gui2-base-jar) &&" +
Sean Condonb2c483c2019-01-16 20:28:55 +0000366 " unzip -q $$ROOT/$(location //web/gui:onos-gui-lion-for-gui2) web/gui/src/main/resources/**/* &&" +
367 " mv web/gui/src/main/resources/org/onosproject/ui/lion* WEB-INF/classes/org/onosproject/ui/ &&" +
368 " mv web/gui/src/main/resources/core WEB-INF/classes/ &&" +
Sean Condon0d064ec2019-02-04 21:53:53 +0000369 " unzip -q $$ROOT/$(location //web/gui:onos-gui-data-for-gui2) web/gui/src/main/webapp/data/**/* &&" +
370 " mv web/gui/src/main/webapp/data WEB-INF/classes/ &&" +
Sean Condon95fb5742019-04-02 12:16:55 +0100371 " find . -type f -exec touch -t 201903200000 {} \; &&" +
Sean Condonb2c483c2019-01-16 20:28:55 +0000372 " jar cmf META-INF/MANIFEST.MF $$ROOT/$@ WEB-INF/web.xml WEB-INF/classes OSGI-INF/*.xml",
Sean Condonf6af2a52018-08-19 10:43:24 +0100373 output_to_bindir = 1,
374 visibility = ["//visibility:public"],
375)
376
377"""
378 Wrap the genrule for testing in a test
379"""
380
381sh_test(
382 name = "onos-gui2-ng-tests",
383 size = "small",
384 srcs = [
385 ":ng-test.sh",
386 ],
387 data = [
388 ":_onos-gui2-ng-test-genrule",
389 ],
390 deps = [
391 "@bazel_tools//tools/bash/runfiles",
392 ],
393)
Sean Condonbf7ff4f2019-03-17 16:18:42 +0000394
395onos_app(
396 category = "Graphical User Interface",
397 description = "ONOS GUI2 - a reengineered version of the original ONOS GUI " +
398 "based on the latest Angular framework components",
399 title = "ONOS GUI2",
400 url = "http://onosproject.org",
401)